> For the complete documentation index, see [llms.txt](https://docs.lagoon.finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.lagoon.finance/developer-hub/integration/synchronous-deposit-flow.md).

# Synchronous deposit flow

## How to do a synchronous deposit ?

Synchronous deposits can be done by calling:

```solidity
function syncDeposit(uint256 assets, address receiver, address referral) payable returns (uint256 shares);
```

| Variable | Definition                                                                |
| -------- | ------------------------------------------------------------------------- |
| assets   | Amount of assets to deposit.                                              |
| receiver | Recipient of the shares.                                                  |
| referral | Address that referred the depositor. Put the address 0 if not applicable. |

## How to know if synchronous deposits are currently possible?

if the function `isTotalAssetsValid()` returns true, users can do synchronous deposits. If it returns false, users must do [async deposits](/developer-hub/integration/async-deposit-flow.md).

```solidity
function isTotalAssetsValid() returns (bool);
```

## Typescript example with viem

Here is an example of how to decide weither a user should do a synchronous or an asynchronous deposit.

```typescript
const isSyncDepositAllowed = await client.readContract({
  abi: vaultAbi,
  address: vault.address,
  functionName: "isTotalAssetsValid",
});

if (isSyncDepositAllowed) {
  await client.writeContract({
    abi: vaultAbi,
    address: vault.address,
    functionName: "syncDeposit", // synchronous deposit
    args: [1000n, user.address, user.address],
  });
} else {
  await client.writeContract({
    abi: vaultAbi,
    address: vault.address,
    functionName: "requestDeposit", // asynchronous deposit
    args: [1000n, user.address, user.address],
  });
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.lagoon.finance/developer-hub/integration/synchronous-deposit-flow.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
